???File Path
==========
***...\Models\travel\TargetModels.cs


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@  SetTargetSplitup  @@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
public class MdlSetTargetSplitup {

	public long binSetTargetSplitupId { get; set; } = 0;
	[Required()]
	[Display(Name = "Set Target")]
	public long binSetTargetId { get; set; } = 0;
	
	[Required()]
	[Display(Name = "Service")]
	public long binServiceId { get; set; } = 0;
	[Required()]
	[Display(Name = "Service Grouping")]
	public long binServiceGroupingId { get; set; } = 0;
	public short sinServiceGroupingSysType { get; set; } = 0;
	public short sinMonth { get; set; } = 0;
	
	public double dblRevenueTargetPerc { get; set; } = 0.0;
	public double dblRevenueTarget { get; set; } = 0.0;
	public double dblYieldTargetPerc { get; set; } = 0.0;
	public double dblYieldTarget { get; set; } = 0.0;
	
}

public class MdlReqSetTargetSplitup : MdlRequest {

	public MdlSetTargetSplitup mdlSetTargetSplitup { get; set; } = new MdlSetTargetSplitup();
}

public class MdlResSetTargetSplitup : MdlResponse {

	public MdlSetTargetSplitup mdlSetTargetSplitup { get; set; } = new MdlSetTargetSplitup();
}

public class MdlResSetTargetSplitupList : MdlResponse {

	public List<MdlSetTargetSplitup> lstMdlSetTargetSplitup { get; set; } = new List<MdlSetTargetSplitup>();
}

public class MdlResSetTargetSplitupInit : MdlResponse {
	public List<MdlBaseIntId> lstMdlSetTargetBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlServiceBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlServiceGroupingBaseIntId { get; set; } = new List<MdlBaseIntId>();


	public List<MdlSetTargetSplitup> lstMdlSetTargetSplitup { get; set; } = new List<MdlSetTargetSplitup>();
}

