???File Path
==========
***...\ClientApp\srcpp\src\travel\set-target-splitup\set-target-splitup.component.ts


???Check the points
==================
1) Check ...\ClientApp\srcpp\srcaseranchranch.component.ts and ...\ClientApp\srcpp\srcase\company\company.component.ts 
2) Main Grouping Must
	-> // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@@
	-> // @@@@@@@ FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@
3) Set GUI Heading in constructor(Eg:- insGlobalConstants.strGuiHeading = "***";)
4) Set GUI/Menu System Name in constructor(Eg:- insGlobalConstants.strSysModuleName = "***";) based on menu service
5) Set GUI Tittle(Browser Tab) in constructor(Eg:- insGlobalFunctions.fnSetGuiBasedBrowserTitle = "***";)



            // ??? Check and Use If you need...
            //---------------------------------
            import { Component, OnInit, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
            import { DxDataGridComponent } from "devextreme-angular";

            import * as globalConstantsService from '../../../services/global-constants.service';
            import * as globalFunctionsService from '../../../services/global-functions.service';
            import * as globalDataService from '../../../services/global-data.service';
            import * as baseDataService from '../../../services/base/base-data.service';
            import * as jspdfService from '../../../services/jspdf.service';
            import * as menuService from '../../../services/menu.service';
            import { MdlSetTargetSplitup, MdlReqSetTargetSplitup, MdlResSetTargetSplitup, MdlResSetTargetSplitupInit, MdlResSetTargetSplitupList } from '../../../models/travel/target.model';
            import { MdlResponse, MdlBaseIntId, MdlReqBaseIntId } from "../../../models/common.model";
            import { HttpService } from '../../../services/http.service';
        


            // ??? Check and Use If you need...
            //---------------------------------
            export class SetTargetSplitupComponent implements OnInit, AfterViewInit, OnDestroy {
                // ** initialize data
                public mdlSetTargetSplitup: MdlSetTargetSplitup = new MdlSetTargetSplitup();
                public intActiveSetTargetSplitupIndex: number = -1;
                // ** Select and Auto-completion
                // ??? Remove not use items !!!
			lstMdlSetTargetBaseIntId: MdlBaseIntId[] = [];
			lstMdlServiceBaseIntId: MdlBaseIntId[] = [];
			lstMdlServiceGroupingBaseIntId: MdlBaseIntId[] = [];

                // ** GUI Control
                public blnBtnDisabled: boolean = false;
                public blnMoreDivExpanded: boolean = false;
                // ** SetTargetSplitup List
                @ViewChild('#idDgSetTargetSplitupList') idDgSetTargetSplitupList!: DxDataGridComponent;
                public lstAllSetTargetSplitup: MdlSetTargetSplitup[] = [];
                public blnDgSetTargetSplitupShowFilterRow: boolean = false;
                public blnDgSetTargetSplitupHeaderFilter: boolean = false;
                public intActiveSetTargetSplitupListItemIndex = -1;
        


                // ??? If you need, import and create instance other common classes !!!
                constructor(public insGlobalConstants: globalConstantsService.GlobalConstantsService,
                        public insGlobalFunctions: globalFunctionsService.GlobalFunctionsService,
                        public insGlobalData: globalDataService.GlobalDataService,
                        public insBaseData: baseDataService.BaseDataService,
                        private insHttpService: HttpService,
                        public insJspdf: jspdfService.JspdfService) {
    
                    insGlobalConstants.strGuiHeading = 'setTargetSplitup';
                    // ??? Check menu service !!!
                    insGlobalConstants.strSysModuleName = "SETTARGETSPLITUP_MASTER";
                    insGlobalFunctions.fnSetGuiBasedBrowserTitle("SetTargetSplitup");
                }

                ngOnInit(): void {
                    this.blnBtnDisabled = true;
                    document.body.style.cursor = "wait";

                    this.fnDefaultView();

                    // initialize Data Request
                    this.insHttpService.get('Base/Organization/GetSetTargetSplitupInitializeData')
                    .then((mdlResSetTargetSplitupInit: MdlResSetTargetSplitupInit) => {
                        if (mdlResSetTargetSplitupInit.sinStatus == 1) {
                            this.lstMdlSetTargetSplitup = mdlResSetTargetSplitupInit.lstMdlSetTargetSplitup;

                            // ??? Remove not use items !!!
					this.lstMdlSetTargetBaseIntId = mdlResSetTargetSplitupInit.lstMdlSetTargetBaseIntId;
					this.lstMdlServiceBaseIntId = mdlResSetTargetSplitupInit.lstMdlServiceBaseIntId;
					this.lstMdlServiceGroupingBaseIntId = mdlResSetTargetSplitupInit.lstMdlServiceGroupingBaseIntId;

                        } else {
                            console.log(mdlResSetTargetSplitupInit.strMessage + " => " + mdlResSetTargetSplitupInit.strErrorCode + ' -> ' + mdlResSetTargetSplitupInit.strSysError);
                        }
                    })
                    .catch((err: any) => {
                        console.log("Error->SETTARGETSPLITUP.COMPONENT.TS#001: " + JSON.stringify(err));
                    });

                    document.body.style.cursor = "default";
                    this.blnBtnDisabled = false;
                }

                ngAfterViewInit(): void {
                }

                ngOnDestroy() {
                }
        


            // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@


            // ??? AUTO/ENTRY COMPLETE - Set Id[, Code, Name] -> OnFocusOut Event

            // ??? Any caculation/Display Based on user inputs

        


            // @@@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            fnOnSetTargetSplitupListEditButtonClick(objSelRow: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objSelRow.row.data, objSelRow.row.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnSetTargetSplitupListRowDblClick(objDblClickRowData: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objDblClickRowData.data, objDblClickRowData.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnDgFilterRowEnableDisableClick() {
                this.blnDgShowFilterRow = !this.blnDgShowFilterRow;
            }

            fnOnDgHeadeFilterEnableDisableClick() {
                this.blnDgHeaderFilter = !this.blnDgHeaderFilter;
            }
        


            // @@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            async fnOnSaveButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, true, false);

            // Add or Update 
            try {
            // Input Validation
            this.fnInputValidation(this.mdlSetTargetSplitup);

            // Input Data set
            //....

            // Set Save Request Inputs
            let mdlReqSetTargetSplitup: MdlReqSetTargetSplitup = new MdlReqSetTargetSplitup();
            mdlReqSetTargetSplitup.mdlSetTargetSplitup = JSON.parse(JSON.stringify(this.mdlSetTargetSplitup));

            // Request Data Reset
            //....

            // Save Request
            await this.insHttpService.post('Base/Organization/SaveSetTargetSplitup', mdlReqSetTargetSplitup)
                .then((mdlResSetTargetSplitup: MdlResSetTargetSplitup) => {
                if (mdlResSetTargetSplitup.sinStatus == 1) {
                    this.mdlSetTargetSplitup = mdlResSetTargetSplitup.mdlSetTargetSplitup;
                    if (this.intActiveSetTargetSplitupIndex == -1) {
                    // New Item
                    this.intActiveSetTargetSplitupIndex = this.lstMdlSetTargetSplitup.length;
                    this.lstMdlSetTargetSplitup.push(JSON.parse(JSON.stringify(this.mdlSetTargetSplitup)));
                    }
                    else {
                    // Update
                    this.lstMdlSetTargetSplitup[this.intActiveSetTargetSplitupIndex] = JSON.parse(JSON.stringify(this.mdlSetTargetSplitup));
                    //this.lstMdlSetTargetSplitup.splice(this.intActiveSetTargetSplitupIndex, 1, this.mdlSetTargetSplitup);
                    }

                    this.insGlobalConstants.fnSetSuccessMessage(mdlResSetTargetSplitup.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResSetTargetSplitup.strMessage, mdlResSetTargetSplitup.strSysError);
                    console.log(mdlResSetTargetSplitup);
                }
                })
                .catch((err: any) => {
                    this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
                if (ex instanceof Error) {
                    //this.insGlobalConstants.strErrorMessages = ex.message;
                    this.insGlobalConstants.fnSetErrorMessage(ex.message);
                }
                console.log("Error->SETTARGETSPLITUP.COMPONENT.TS#002: " + ex);
            }

            this.fnDefaultView(false, false, true, false);
            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        fnOnNewButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";

            this.fnDefaultView(true, true, true, false);

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        async fnOnDeleteButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, false, false);

            // Delete 
            try {

            // Input Validation
            if (this.mdlSetTargetSplitup.binSetTargetSplitupId == null || this.mdlSetTargetSplitup.binSetTargetSplitupId < 1) {
                throw new Error('Select SetTargetSplitup for DELETE.');
            }

            // Set Delete Request Inputs
            let mdlReqSetTargetSplitupBaseIntId: MdlReqBaseIntId = new MdlReqBaseIntId();
            mdlReqSetTargetSplitupBaseIntId.mdlBaseIntId.binPkId = this.mdlSetTargetSplitup.binSetTargetSplitupId;
            mdlReqSetTargetSplitupBaseIntId.mdlBaseIntId.binCustomValue = this.mdlSetTargetSplitup.intSysActionId;
            
            // Delete Request
            await this.insHttpService.post('Base/Organization/DeleteSetTargetSplitup', mdlReqSetTargetSplitupBaseIntId)
                .then((mdlResponse: MdlResponse) => {
                if (mdlResponse.sinStatus == 1) {
                    this.lstMdlSetTargetSplitup.splice(this.intActiveSetTargetSplitupIndex, 1);
                    this.fnDefaultView(true, false, false, false);
                    this.insGlobalConstants.fnSetSuccessMessage(mdlResponse.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResponse.strMessage, mdlResponse.strSysError);
                    console.log(mdlResponse);
                }
                })
                .catch((err: any) => {
                this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
            if (ex instanceof Error) {
                this.insGlobalConstants.fnSetErrorMessage(ex.message);
            }
            console.log("Error->SETTARGETSPLITUP.COMPONENT.TS#003: " + ex);
            }

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        


            // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


            fnDefaultView(blnClearData: boolean = true, blnClearMessages: boolean = true, blnMoreDivExpanded: boolean = false, blnGotoBottom: boolean = false) {
                if (blnClearData) {
                    this.mdlSetTargetSplitup = new MdlSetTargetSplitup();
                    this.intActiveSetTargetSplitupIndex = -1;
                }

                this.blnMoreDivExpanded = blnMoreDivExpanded;

                if (blnClearMessages) {
                    this.insGlobalConstants.strErrorMessages = "";
                    this.insGlobalConstants.strSuccessMessages = "";
                }
                
                if (!blnGotoBottom)
                    this.insGlobalFunctions.fnWindowScrollTop();
                else {
                    this.insGlobalFunctions.fnWindowScrollbottom();
                }
            }

            fnSetDataAndGuiEditMode(mdlSetTargetSplitup: MdlSetTargetSplitup, intRowIndex: number) {
                this.mdlSetTargetSplitup = JSON.parse(JSON.stringify(mdlSetTargetSplitup));
                this.intActiveSetTargetSplitupIndex = intRowIndex;
                this.fnDefaultView(false, true, true, false);
            }

            fnInputValidation(mdlSetTargetSplitup: MdlSetTargetSplitup) {
                // ??? CHECK
                
                if (mdlSetTargetSplitup.binSetTargetId == 0) {
                    throw new Error('Enter/Select Set Target.');
                }
            
                if (mdlSetTargetSplitup.binServiceId == 0) {
                    throw new Error('Enter/Select Service.');
                }
            
                if (mdlSetTargetSplitup.binServiceGroupingId == 0) {
                    throw new Error('Enter/Select Service Grouping.');
                }
            

                // ??? CHECK CODE and NAME [Other UNIQUE Fields] Already exists
            }
        

