???File Path
==========
***...\Src\Travel\SetTargetSplitup.cs




???Check the points
==================



            // ??? IMPORT:- Add the items top - Duplcation Avoid
            using System;
            using System.Data;
            using System.Collections.Generic;
            using Npgsql;
            using NpgsqlTypes;

            using TAAS.Db;
            using TAAS.Models;
            using TAAS.Models.Travel;
            using TAAS.Helpers;
        


            // ??? CLASS ATTRIBUTES:- The code past top of the class(Attributes) - Duplcation Avoid
            public GlobalFunctions insGlobalFunctions = new GlobalFunctions();
            DbService insDbService = new();
        


            public List<MdlBaseIntId> FnGetAllSetTargetSplitupBaseData()
            {
                List<MdlBaseIntId> lstMdlSetTargetSplitupBaseIntId = new List<MdlBaseIntId>();

                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_set_target_splitup()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlBaseIntId mdlBaseIntId = new MdlBaseIntId();

                        mdlBaseIntId.binPkId = (DBNull.Value != objRecord["pk_set_target_splitup_id"]) ? (long)Convert.ToUInt64(objRecord["pk_set_target_splitup_id"]) : mdlBaseIntId.binPkId;
                        mdlBaseIntId.strCode = (DBNull.Value != objRecord[""]) ? Convert.ToString(objRecord[""]) : mdlBaseIntId.strCode;
                        mdlBaseIntId.strName = (DBNull.Value != objRecord[""]) ? Convert.ToString(objRecord[""]) : mdlBaseIntId.strName;
        
                        lstMdlSetTargetSplitupBaseIntId.Add(mdlBaseIntId);
                    }
                }

                return lstMdlSetTargetSplitupBaseIntId;
            }
        


            public List<MdlSetTargetSplitup> FnGetAllSetTargetSplitupWithActionUser()
            {
                List<MdlSetTargetSplitup> lstMdlSetTargetSplitup = new List<MdlSetTargetSplitup>();
                
                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_set_target_splitup_with_action_user()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlSetTargetSplitup mdlSetTargetSplitup = new MdlSetTargetSplitup();

                        
				mdlSetTargetSplitup.binSetTargetSplitupId = (DBNull.Value != objRecord["pk_set_target_splitup_id"]) ? (long)Convert.ToInt64(objRecord["pk_set_target_splitup_id"]) : mdlSetTargetSplitup.binSetTargetSplitupId;
				mdlSetTargetSplitup.binSetTargetId = (DBNull.Value != objRecord["fk_set_target_id"]) ? (long)Convert.ToInt64(objRecord["fk_set_target_id"]) : mdlSetTargetSplitup.binSetTargetId;

				mdlSetTargetSplitup.binServiceId = (DBNull.Value != objRecord["fk_service_id"]) ? (long)Convert.ToInt64(objRecord["fk_service_id"]) : mdlSetTargetSplitup.binServiceId;
				mdlSetTargetSplitup.binServiceGroupingId = (DBNull.Value != objRecord["fk_service_grouping_id"]) ? (long)Convert.ToInt64(objRecord["fk_service_grouping_id"]) : mdlSetTargetSplitup.binServiceGroupingId;
				mdlSetTargetSplitup.sinServiceGroupingSysType = (DBNull.Value != objRecord["sin_service_grouping_sys_type"]) ? (short)Convert.ToInt16(objRecord["sin_service_grouping_sys_type"]) : mdlSetTargetSplitup.sinServiceGroupingSysType;
				mdlSetTargetSplitup.sinMonth = (DBNull.Value != objRecord["sin_month"]) ? (short)Convert.ToInt16(objRecord["sin_month"]) : mdlSetTargetSplitup.sinMonth;

				mdlSetTargetSplitup.dblRevenueTargetPerc = (DBNull.Value != objRecord["dbl_revenue_target_perc"]) ? (double)Convert.ToDouble(objRecord["dbl_revenue_target_perc"]) : mdlSetTargetSplitup.dblRevenueTargetPerc;
				mdlSetTargetSplitup.dblRevenueTarget = (DBNull.Value != objRecord["dbl_revenue_target"]) ? (double)Convert.ToDouble(objRecord["dbl_revenue_target"]) : mdlSetTargetSplitup.dblRevenueTarget;
				mdlSetTargetSplitup.dblYieldTargetPerc = (DBNull.Value != objRecord["dbl_yield_target_perc"]) ? (double)Convert.ToDouble(objRecord["dbl_yield_target_perc"]) : mdlSetTargetSplitup.dblYieldTargetPerc;
				mdlSetTargetSplitup.dblYieldTarget = (DBNull.Value != objRecord["dbl_yield_target"]) ? (double)Convert.ToDouble(objRecord["dbl_yield_target"]) : mdlSetTargetSplitup.dblYieldTarget;


        
                        lstMdlSetTargetSplitup.Add(mdlSetTargetSplitup);
                    }
                }

                return lstMdlSetTargetSplitup;
            }
        


            public MdlResSetTargetSplitup FnInsertOrUpdateSetTargetSplitup(MdlReqSetTargetSplitup mdlReqSetTargetSplitup)
            {
                // *** Input Validation INSERT and UPDATE Case[not duplicate model validation]
                // ??? Duplication Checking in DB FUCTION(Insert and Update) - CODE, NAME [, other unique fields] Already exists
                // ??? Count Exced or other checking License related in DB FUCTION(Insert)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)

                // Set Create or modified User in DB FUCTION(Insert, Update and Delete)
                if (mdlReqSetTargetSplitup.mdlSetTargetSplitup.binSetTargetSplitupId == 0)
                {
                    mdlReqSetTargetSplitup.mdlSetTargetSplitup.intSysActionId = 0;
                    mdlReqSetTargetSplitup.mdlSetTargetSplitup.binCreatedUserId = mdlReqSetTargetSplitup.linLoginUserId;
                    mdlReqSetTargetSplitup.mdlSetTargetSplitup.strCreatedUser = mdlReqSetTargetSplitup.strLoginUserName;
                    mdlReqSetTargetSplitup.mdlSetTargetSplitup.dtmCreated = mdlReqSetTargetSplitup.dtmCurrentDateTime;
                }
                else {
                    mdlReqSetTargetSplitup.mdlSetTargetSplitup.binLastModifiedUserId = mdlReqSetTargetSplitup.linLoginUserId;
                    mdlReqSetTargetSplitup.mdlSetTargetSplitup.strLastModifiedUser = mdlReqSetTargetSplitup.strLoginUserName;
                    mdlReqSetTargetSplitup.mdlSetTargetSplitup.dtmLastModified = mdlReqSetTargetSplitup.dtmCurrentDateTime;
                }

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("mdlSetTargetSplitup", NpgsqlDbType.Jsonb) { Value = mdlReqSetTargetSplitup.mdlSetTargetSplitup, DataTypeName = "jsnSetTargetSplitup"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_insert_or_update_setTargetSplitup(:mdlSetTargetSplitup, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "SETTARGETSPLITUP.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "SETTARGETSPLITUP.CS#002", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "SETTARGETSPLITUP.CS#003", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Saved
                MdlResSetTargetSplitup mdlResSetTargetSplitup = new MdlResSetTargetSplitup();
                mdlResSetTargetSplitup.mdlSetTargetSplitup = mdlSetTargetSplitupReq.mdlSetTargetSplitup;
                if (mdlReqSetTargetSplitup.mdlSetTargetSplitup.binSetTargetSplitupId == 0)
                {
                    mdlResSetTargetSplitup.mdlSetTargetSplitup.binSetTargetSplitupId = mdlDbResponse.binSqlPk ?? 0;
                    mdlResSetTargetSplitup.mdlSetTargetSplitup.dtmCreated = mdlDbResponse.dtmCurrent;
                }
                else
                {
                    mdlResSetTargetSplitup.mdlSetTargetSplitup.intSysActionId += 1;
                    mdlResSetTargetSplitup.mdlSetTargetSplitup.dtmLastModified = mdlDbResponse.dtmCurrent;
                }
                mdlResSetTargetSplitup.sinStatus = 1;
                mdlResSetTargetSplitup.strStatusCode = "SUCCESS";
                mdlResSetTargetSplitup.strMessage = "SETTARGETSPLITUP has been Saved.";
                
                return mdlResSetTargetSplitup;
            } 
        


            public MdlResBaseIntId FnDeleteSetTargetSplitup(MdlReqBaseIntId mdlReqSetTargetSplitupBaseIntId)
            {
                // *** Input Validation DELETE Case[not duplicate model validation]
                // ??? FOREIGN KEY REFERENCES Ching in DB FUCTION(Delete)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)
                // ??? Set Create or modified User in DB FUCTION(Insert, Update and Delete)

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("binSetTargetSplitupId", NpgsqlDbType.Bigint) { Value = mdlReqSetTargetSplitupBaseIntId.mdlBaseIntId.binPkId, DataTypeName = "binSetTargetSplitupId"},
                    new NpgsqlParameter("intSysActionId", NpgsqlDbType.Integer) { Value = mdlReqSetTargetSplitupBaseIntId.mdlBaseIntId.binCustomValue, DataTypeName = "intSysActionId"},
                    new NpgsqlParameter("binDeletedUserId", NpgsqlDbType.Bigint) { Value = mdlReqSetTargetSplitupBaseIntId.linLoginUserId, DataTypeName = "binDeletedUserId"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_delete_setTargetSplitup(:binSetTargetSplitupId, :intSysActionId, :binDeletedUserId, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "SETTARGETSPLITUP.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "SETTARGETSPLITUP.CS#005", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "SETTARGETSPLITUP.CS#006", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Deleted
                MdlResBaseIntId mdlResSetTargetSplitupIntId = new MdlResBaseIntId();

                mdlResSetTargetSplitupIntId.mdlBaseIntId = mdlReqSetTargetSplitupBaseIntId.mdlBaseIntId;
                mdlResSetTargetSplitupIntId.sinStatus = 1;
                mdlResSetTargetSplitupIntId.strStatusCode = "SUCCESS";
                mdlResSetTargetSplitupIntId.strMessage = "SETTARGETSPLITUP has been deleted.";

                return mdlResSetTargetSplitupIntId;
            }
        

